<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DatosBase StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:DatosBase
 * @subpackage Structs
 */
class DatosBase extends AbstractStructBase
{
    /**
     * The Asegurado
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \StructType\Asegurado
     */
    public $Asegurado;
    /**
     * The declaraConductorMenor30Anios
     * @var bool
     */
    public $declaraConductorMenor30Anios;
    /**
     * The formaPago
     * @var \StructType\FormaPago
     */
    public $formaPago;
    /**
     * The recargoDescuento
     * @var string
     */
    public $recargoDescuento;
    /**
     * The valorRecargo
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $valorRecargo;
    /**
     * Constructor method for DatosBase
     * @uses DatosBase::setAsegurado()
     * @uses DatosBase::setDeclaraConductorMenor30Anios()
     * @uses DatosBase::setFormaPago()
     * @uses DatosBase::setRecargoDescuento()
     * @uses DatosBase::setValorRecargo()
     * @param \StructType\Asegurado $asegurado
     * @param bool $declaraConductorMenor30Anios
     * @param \StructType\FormaPago $formaPago
     * @param string $recargoDescuento
     * @param string $valorRecargo
     */
    public function __construct(\StructType\Asegurado $asegurado = null, $declaraConductorMenor30Anios = null, \StructType\FormaPago $formaPago = null, $recargoDescuento = null, $valorRecargo = null)
    {
        $this
            ->setAsegurado($asegurado)
            ->setDeclaraConductorMenor30Anios($declaraConductorMenor30Anios)
            ->setFormaPago($formaPago)
            ->setRecargoDescuento($recargoDescuento)
            ->setValorRecargo($valorRecargo);
    }
    /**
     * Get Asegurado value
     * @return \StructType\Asegurado|null
     */
    public function getAsegurado()
    {
        return $this->Asegurado;
    }
    /**
     * Set Asegurado value
     * @param \StructType\Asegurado $asegurado
     * @return \StructType\DatosBase
     */
    public function setAsegurado(\StructType\Asegurado $asegurado = null)
    {
        $this->Asegurado = $asegurado;
        return $this;
    }
    /**
     * Get declaraConductorMenor30Anios value
     * @return bool|null
     */
    public function getDeclaraConductorMenor30Anios()
    {
        return $this->declaraConductorMenor30Anios;
    }
    /**
     * Set declaraConductorMenor30Anios value
     * @param bool $declaraConductorMenor30Anios
     * @return \StructType\DatosBase
     */
    public function setDeclaraConductorMenor30Anios($declaraConductorMenor30Anios = null)
    {
        // validation for constraint: boolean
        if (!is_null($declaraConductorMenor30Anios) && !is_bool($declaraConductorMenor30Anios)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($declaraConductorMenor30Anios, true), gettype($declaraConductorMenor30Anios)), __LINE__);
        }
        $this->declaraConductorMenor30Anios = $declaraConductorMenor30Anios;
        return $this;
    }
    /**
     * Get formaPago value
     * @return \StructType\FormaPago|null
     */
    public function getFormaPago()
    {
        return $this->formaPago;
    }
    /**
     * Set formaPago value
     * @param \StructType\FormaPago $formaPago
     * @return \StructType\DatosBase
     */
    public function setFormaPago(\StructType\FormaPago $formaPago = null)
    {
        $this->formaPago = $formaPago;
        return $this;
    }
    /**
     * Get recargoDescuento value
     * @return string|null
     */
    public function getRecargoDescuento()
    {
        return $this->recargoDescuento;
    }
    /**
     * Set recargoDescuento value
     * @uses \EnumType\RecargoDescuento::valueIsValid()
     * @uses \EnumType\RecargoDescuento::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $recargoDescuento
     * @return \StructType\DatosBase
     */
    public function setRecargoDescuento($recargoDescuento = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\RecargoDescuento::valueIsValid($recargoDescuento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\RecargoDescuento', is_array($recargoDescuento) ? implode(', ', $recargoDescuento) : var_export($recargoDescuento, true), implode(', ', \EnumType\RecargoDescuento::getValidValues())), __LINE__);
        }
        $this->recargoDescuento = $recargoDescuento;
        return $this;
    }
    /**
     * Get valorRecargo value
     * @return string|null
     */
    public function getValorRecargo()
    {
        return $this->valorRecargo;
    }
    /**
     * Set valorRecargo value
     * @param string $valorRecargo
     * @return \StructType\DatosBase
     */
    public function setValorRecargo($valorRecargo = null)
    {
        // validation for constraint: string
        if (!is_null($valorRecargo) && !is_string($valorRecargo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($valorRecargo, true), gettype($valorRecargo)), __LINE__);
        }
        $this->valorRecargo = $valorRecargo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DatosBase
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
